////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Project   :  "     "
//  * Details   : http://alexander-bagel.blogspot.ru/2013/05/intercept2.html
//  * Unit Name : uRtlCreateUnicodeStringHook
//  * Purpose   :    
//  * Author    :  (Rouse_) 
//  * Version   : 1.0
//  * Home Page : http://rouse.drkb.ru
//  * Home Blog : http://alexander-bagel.blogspot.com/
//  ****************************************************************************
//  

unit uRtlCreateUnicodeStringHook;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SpliceHelper;

type
  TForm2 = class(TForm)
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

type
  UNICODE_STRING = record
    Length: WORD;
    MaximumLength: WORD;
    Buffer: PWideChar;
  end;
  PUNICODE_STRING = ^UNICODE_STRING;

  function  RtlCreateUnicodeString(DestinationString: PUNICODE_STRING;
    SourceString: PWideChar): BOOLEAN; stdcall; external 'ntdll.dll';

var
  HotPathSpliceRec: THotPachSpliceData;

function TrampolineRtlCreateUnicodeString(DestinationString: PUNICODE_STRING;
  SourceString: PWideChar): Integer; stdcall;
begin
  asm
    db $90, $90, $90, $90, $90, $90, $90
  end;
end;

function InterceptedRtlCreateUnicodeString(DestinationString: PUNICODE_STRING;
  SourceString: PWideChar): Integer; stdcall;
begin
  Result := TrampolineRtlCreateUnicodeString(DestinationString, SourceString);
  ShowMessage(DestinationString^.Buffer);
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  //      
  InitHotPatchSpliceRecEx('ntdll.dll', 'RtlCreateUnicodeString',
    @InterceptedRtlCreateUnicodeString, @TrampolineRtlCreateUnicodeString,
    HotPathSpliceRec);
  //     NOP-
  SpliceNearJmp(PAnsiChar(HotPathSpliceRec.FuncAddr) - NearJmpSpliceRecSize,
    HotPathSpliceRec.SpliceRec);
end;

procedure TForm2.Button1Click(Sender: TObject);
var
  US: UNICODE_STRING;
begin
  //  RtlCreateUnicodeString
  SpliceLockJmp(HotPathSpliceRec.FuncAddr, LOCK_JMP_OPKODE);
  try
    RtlCreateUnicodeString(@US, 'Test UNICODE String');
  finally
    //  
    SpliceLockJmp(HotPathSpliceRec.FuncAddr, HotPathSpliceRec.LockJmp);
  end;
end;

end.
